#ifndef GUARD_mainwin_h
#define GUARD_mainwin_h

// air is little image thumbnail program.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
// All comments are korean, UTF-8 encoding.

#include <list>
#include <string>

#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/menu.h>
#include <gtkmm/menubar.h>
#include <gtkmm/fileselection.h>
#include <gtkmm/messagedialog.h>

#include "preference.h"

class MainWnd: public Gtk::Window
{
    public:
	MainWnd();
	~MainWnd();

    private:
	Preference preference_;	
	
	Gtk::VBox mainBox_;
	Gtk::MenuBar menuBar_;
	Gtk::Menu fileMenu_, editMenu_, aboutMenu_;

	std::list<std::string> selectedFiles_;
	
	void OnMenuFileopen();
	void OnMenuFolderopen();
	void OnMenuPreferences();
	void OnMenuAbout();
	void OnMenuQuit();
	
	void AddFormatInfo(Glib::ustring&);

};

struct GetFormatName
: public std::binary_function<Glib::ustring*, Gdk::PixbufFormat, void>
{
    void operator()(Glib::ustring* p1, const Gdk::PixbufFormat& p2) const
    {
	*p1 += p2.get_name();
	*p1 += ' ';
    }
};

#endif
