#ifndef GUARD_morescalewin_h
#define GUARD_morescalewin_h

// air is little image thumbnail program.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
// All comments are korean, UTF-8 encoding.

#include <list>
#include <string>

#include <gdkmm.h>
#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/table.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/textview.h>
#include <gtkmm/textbuffer.h>
#include <gtkmm/button.h>
#include <gtkmm/stock.h>
#include <gtkmm/label.h>
#include <gtkmm/frame.h>
#include <gtkmm/messagedialog.h>

#include "preference.h"
#include "misc.h"

class ChooseWnd : public Gtk::Window
{
    public:
	ChooseWnd(const Preference&, std::list<std::string>);
	~ChooseWnd();

    private:
	std::list<std::string> filenames_;

	Gtk::Table mainTable_;
	Gtk::HBox infoBox_, extRadioBox_;	
	Gtk::HButtonBox mainBtnBox_;
	Gtk::Image infoIcon_;
	Gtk::Label infoHeadLabel_, infoLabel_;
	Gtk::Label dummyLabel1, dummyLabel2;
	Gtk::Label batchHeadLabel_;
	Gtk::Label widthLabel_, heightLabel_, typeLabel_;
	Gtk::Label dummyLabel3, dummyLabel4;
	Gtk::RadioButton eachProc_;
	Gtk::RadioButton batchProc_;
	Gtk::SpinButton widthSpin_;
	Gtk::SpinButton heightSpin_;
	Gtk::Button cancelBtn_, okBtn_;
	Gtk::Adjustment widthAdj_, heightAdj_;
	Gtk::HSeparator btnBoxSeparator_; 
	
	const Preference& preference_;

	std::string ext_;
	
	void OnRadioBatch();
	void OnRadioExt(const std::string&);
	void OnBtnCancel();
	void OnBtnOk();

};

class MoreScaleWnd : public Gtk::Window
{
    public:
	MoreScaleWnd(const Preference&, int, int, std::list<std::string>, std::string);
	~MoreScaleWnd();

    private:
	std::list<std::string> filenames_;

	Gtk::Table mainTable_;
	Gtk::VBox progressBox_;
	Gtk::HButtonBox mainBtnBox_;
	Gtk::ProgressBar progressBar_;
	Gtk::Label infoHeadLabel_, infoLabel_;
	Gtk::Label subLabel_;
	Gtk::Label dummyLabel_;
	Gtk::Button cancelBtn_, pauseBtn_;

	Glib::ustring progressBarText_;
	Glib::ustring subLabelText_;
	std::string ext_;

	Glib::Dispatcher signalSetProgressBarText_;
	Glib::Dispatcher signalSetProgressBarFraction_;
	Glib::Dispatcher signalSetSubLabelText_;
	Glib::Dispatcher signalUpdatePreview_;
	Glib::Dispatcher signalFileExistsErr_;
	Glib::Dispatcher signalExecFinish_;

	double progressBarFraction_;

	Glib::RefPtr<Gdk::Pixbuf> image_;

	const Preference& preference_;

	PreviewArea* previewArea_;

	Glib::Thread* execThread_;

	virtual bool on_delete_event(GdkEventAny*);
	void SaveFile(Glib::RefPtr<Gdk::Pixbuf>, std::string&);

	void OnShow();
	void Exec();
	void OnBtnPause();
	void OnBtnCancel();
	void SetProgressBarText();
	void SetProgressBarFraction();
	void SetSubLabel();
	void UpdatePreview();	
	void FileExistsErrDlg();
	void ExecFinish();

	unsigned int width_;
	unsigned int height_;
	unsigned int totalFileNum_;
	unsigned int fileCount_;
	int errDlgResponse;
	bool inPause_;
	bool breakThread_;
	bool endThread_;
	bool errDlgGetResponse;

};

#endif
