#ifndef GUARD_prefwindow_h
#define GUARD_prefwindow_h

// air is little image thumbnail program.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
// All comments are korean, UTF-8 encoding.

#include <gdkmm.h>
#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/button.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/scale.h>
#include <gtkmm/entry.h>
#include <gtkmm/table.h>
#include <gtkmm/menu.h>
#include <gtkmm/optionmenu.h>
#include <gtkmm/label.h>
#include <gtkmm/stock.h>
#include <gtkmm/separator.h>
#include <gtkmm/messagedialog.h>
#include <gtkmm/tooltips.h>

#include "preference.h"

class PrefWnd;

class PrefWnd: public Gtk::Window
{
    public:
	PrefWnd(Preference&);
	~PrefWnd();

	friend void operator<<(Preference&, const PrefWnd&);
	friend void operator<<(std::ostream&, const PrefWnd&);
	
    private:
	Gtk::Table mainTable_;
	Gtk::HButtonBox mainBtnBox_;
	Gtk::HBox fileaddRadioBox_;

	Gtk::Menu interpMenu_;
	Gtk::OptionMenu interpOptionMenu_;

	Gtk::Label baseHeadLabel_, baseInterpLabel_, baseJpegcompLabel_;
	Gtk::Label batchHeadLabel_, batchFileaddLabel_;
	Gtk::Label dummyLabel1_, dummyLabel2_, dummyLabel3_, dummyLabel4_;

	Gtk::RadioButton prefixBtn_;
	Gtk::RadioButton suffixBtn_;
	Gtk::RadioButton overwriteBtn_;

	Gtk::CheckButton previewBtn_;
	Gtk::CheckButton stoperrorBtn_;
	Gtk::CheckButton recursiveBtn_;
	Gtk::CheckButton extFilterBtn_;

	Gtk::Button saveBtn_, cancelBtn_, applyBtn_;

	Gtk::HScale jpegcompScale_;

	Gtk::Entry fileaddEntry_;

	Gtk::Tooltips previewTooltips_;
	Gtk::Tooltips extfilterTooltips_;
	Gtk::Tooltips interpTooltips_;
	Gtk::Tooltips jpegcompTooltips_;
	Gtk::Tooltips errstopTooltips_;
	Gtk::Tooltips recursiveTooltips_;
	Gtk::Tooltips prefixTooltips_, suffixTooltips_, overwriteTooltips_;

	Gtk::HSeparator btnBoxSeparator_; 

	Gdk::InterpType interpType_;
	FileAddType fileaddType_;

	Preference& preference_;
	
	void OnBtnCancel();
	void OnBtnSave();
	void OnBtnApply();
	void OnMenuInterp(Gdk::InterpType);
	void OnBtnFileadd(FileAddType);

};

void operator<<(Preference&, const PrefWnd&);
void operator<<(std::ostream&, const PrefWnd&);

#endif
