#ifndef GUARD_singlescalewin_h
#define GUARD_singlescalewin_h

// air is little image thumbnail program.
// Copyright (C) 2004 HG, Rhee <ez8tank@krpost.net>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
// All comments are korean, UTF-8 encoding.

#include <vector>
#include <string>

#include <gdkmm.h>
#include <gtkmm/window.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/box.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/entry.h>
#include <gtkmm/frame.h>
#include <gtkmm/separator.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/button.h>
#include <gtkmm/stock.h>
#include <gtkmm/alignment.h>
#include <gtkmm/table.h>
#include <gtkmm/messagedialog.h>
#include <gtkmm/fileselection.h>

#include "preference.h"
#include "misc.h"

class SingleScaleWnd: public Gtk::Window
{
    public:
	SingleScaleWnd(const Preference&, const std::string&, Glib::RefPtr<Gdk::Pixbuf>);
	~SingleScaleWnd();

    private:
	Gtk::Table mainTable_;
	Gtk::HBox typeRadioBox_;
	Gtk::HBox entryBox_;
	Gtk::HButtonBox mainBtnBox_;

	Gtk::Label infoHeadLabel_, infoFilenameLabel1_, infoFilenameLabel2_;
	Gtk::Label infoSizeLabel1_, infoSizeLabel2_;
	Gtk::Label setHeadLabel_, setWidthLabel_, setHeightLabel_;
	Gtk::Label setWidthRatioLabel_, setHeightRatioLabel_;
	Gtk::Label setTypeLabel_, setFilenameLabel_;
	Gtk::Label dummyLabel1_, dummyLabel2_, dummyLabel3_, dummyLabel4_;

	Gtk::CheckButton sameScaleBtn_;	
	Gtk::Button browseBtn_, cancelBtn_, okBtn_;
	
	Gtk::Entry filenameEntry_;

	Gtk::SpinButton newWidthSpin_;
	Gtk::SpinButton newHeightSpin_;
	Gtk::SpinButton xScaleSpin_;	
	Gtk::SpinButton yScaleSpin_;

	Gtk::Adjustment widthAdj_, heightAdj_, widthRatioAdj_, heightRatioAdj_;

	Gtk::HSeparator btnBoxSeparator_;

	std::vector<std::string> origFile_;
	std::string ext_;

	const Preference& preference_;

	PreviewArea* previewArea_;	

	Glib::RefPtr<Gdk::Pixbuf> origImage_;

	void OnSpinBtnWidth();
	void OnSpinBtnHeight();
	void OnSpinBtnX();
	void OnSpinBtnY();
	void OnCheckBtnSamescale();
	void OnRadioBtnExt(const std::string&);
	void OnBtnBrowse();
	void OnBtnCancel();
	void OnBtnOk();

	void SaveFile();

};

#endif
